﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WinGridBindingList
{
    public partial class Form1 : Form
    {
        BindingList<Patient> ListPatients;
        BindingList<Medicine> ListMedicine;
        public Form1()
        {
            InitializeComponent();
            ListPatients = GeneratePatient();
            //ListPatients.ListChanged += new ListChangedEventHandler(ListPatients_ListChanged);
            //ListMedicine.ListChanged += new ListChangedEventHandler(ListMedicine_ListChanged);
            ultraGrid1.DataSource = ListPatients;
            this.ultraGrid1.SyncWithCurrencyManager = false;
            this.ultraGrid1.Rows.ExpandAll(true);
        }

        void ListMedicine_ListChanged(object sender, ListChangedEventArgs e)
        {
            MessageBox.Show("ListChanged is fired for ListMedicine");
        }

        void ListPatients_ListChanged(object sender, ListChangedEventArgs e)
        {
            MessageBox.Show("ListChanged is fired for ListPatients");
        }
        BindingList<Patient> retPatients = null;
        private BindingList<Patient> GeneratePatient()
        {
            retPatients = new BindingList<Patient>();
            retPatients.Add(new Patient(0, "Ivan",0));
            retPatients.Add(new Patient(1, "Frank",1));
            retPatients.Add(new Patient(2, "Jeff",2));
            retPatients.Add(new Patient(3, "Criss",3));
            //Patient p = new Patient(99, "Child", 9);
            //p.Children = retPatients;
            //retPatients.Add(p);
            return retPatients;
        }

        //private BindingList<Medicine> GenerateMedicine()
        //{
        //    BindingList<Medicine> retMedicine = new BindingList<Medicine>();
        //    retMedicine.Add(new Medicine(0,"Analgin"));
        //    retMedicine.Add(new Medicine(1, "Ferveks"));
        //    retMedicine.Add(new Medicine(2, "Aspirin"));
        //    retMedicine.Add(new Medicine(3, "Vitamin C"));
        //    return retMedicine;
        //}

        private void button1_Click(object sender, EventArgs e)
        {
            Patient pp = this.ultraGrid1.ActiveRow.ListObject as Patient;
            Patient p = new Patient(88, "NewChild", 3);
            //Patient pp = retPatients.FirstOrDefault(a => a.Id == 3);
           pp.Children = new BindingList<Patient>();
           pp.Children.Add(p);
           //this.ultraGrid1.Rows.Refresh(Infragistics.Win.UltraWinGrid.RefreshRow.ReloadData);
           this.ultraGrid1.Rows.ExpandAll(true);
           
        }
    }
}
